#!/bin/sh

xterm_pid=$(cat /tmp/mvdupd_xterm.pid)
rm /tmp/mvdupd_xterm.pid
curl_proxyargs=" --proxy http://127.0.0.1:8082"

function is_this_template(){
	if curl -s 127.0.0.1:8082
	then
		echo "This is a template"
		return 1
	else
		echo "This is not a template"
		return 0
	fi
}

function get_latest_mullvad(){
	if [ $1 = 1 ]
	then
		proxyargs=$curl_proxyargs
	else
		proxyargs=" "
	fi
	su -- user -c "curl$proxyargs -s https://github.com/mullvad/mullvad-browser/releases | grep '/mullvad/mullvad-browser/releases/tag/' | rev | cut -d' ' -f1 | rev | cut -d'<' -f1 | sort -V | sed 's,/.*,,;s,\.$,,' | grep -v a | tail -n1"
}

function get_current_mullvad(){
	grep "Mullvad Browser" /opt/mullvad-browser/Browser/MullvadBrowser/Docs/ChangeLog.txt | head -n1 | cut -d' ' -f3
}

function setup_gpg(){
	if [ $1 = 1 ]
	then
		proxyargs=$curl_proxyargs
	else
		proxyargs=""
	fi
	curl$proxyargs -L https://openpgpkey.torproject.org/.well-known/openpgpkey/torproject.org/hu/kounek7zrdx745qydx6p59t9mqjpuhdf -o /tmp/tor-project-key.gpg
	gpg --import /tmp/tor-project-key.gpg
	echo -e "5\ny\n" | gpg --command-fd=0 --edit-key EF6E286DDA85EA2A4BA7DE684E2C6E8793298290 trust
}

function install_mullvad(){
	echo "Installing/updating Mullvad Browser..."
	if [ $1 = 1 ]
        then
                proxyargs=$curl_proxyargs
        else
                proxyargs=" "
        fi
	setup_gpg $IS_TEMPLATE
	echo '0' > /tmp/mullvad-browser.success
	su -- user -c "curl$proxyargs -sSL 'https://mullvad.net/en/download/browser/linux64/latest/signature' -o /tmp/mullvad-browser.tar.xz.asc" &&
	su -- user -c "curl$proxyargs -L 'https://mullvad.net/en/download/browser/linux64/latest' -o /tmp/mullvad-browser.tar.xz" &&
	chmod 600 /tmp/mullvad-browser.tar.xz{,.asc}
	cd /tmp &&
	gpg --verify mullvad-browser.tar.xz.asc &&
	cd /opt &&
	tar xvf /tmp/mullvad-browser.tar.xz &&
	echo '1' > /tmp/mullvad-browser.success 
	if [ $(cat /tmp/mullvad-browser.success) = 1 ]
	then
		chown root:root -R -v /opt/mullvad-browser
		chmod 755 -R -v /opt/mullvad-browser
		mkdir /opt/mullvad-browser/Data
		chmod 700 -R -v /opt/mullvad-browser/Data
		chown user:user -R -v /opt/mullvad-browser/Data
		date +%s > /var/log/mullvad-browser-installer-updater.lastexit.log
		echo $(date)" : Mullvad Browser installed successfully !"
		echo "If it hasn't already, you can safely close this window, you can also close it with Ctrl+C"
		kill $xterm_pid
		exit 0
	else
		rm -rf /tmp/mullvad-browser{.success,.tar.xz{,.asc}}
		echo "Something went wrong :("
		echo "If this is happening and you have internet access, please open an issue at:" 
		echo "https://codeberg.org/fcom/mullvad-browser-qubes" 
		echo "and explain what you were doing, how your qube is set up, etc..."
		echo "You can safely close this window, you can also close it with Ctrl+C"
		exit 1
	fi

}
is_this_template
IS_TEMPLATE="$?"
if ! [ -d /opt/mullvad-browser ]
then
	echo "Mullvad Browser is not installed"
	install_mullvad $IS_TEMPLATE
else
	LATEST_MULLVAD=$(get_latest_mullvad $IS_TEMPLATE)
	echo Latest Mullvad Browser version: $LATEST_MULLVAD
	CURRENT_MULLVAD=$(get_current_mullvad)
	echo Current Mullvad Browser version: $CURRENT_MULLVAD
	if [ $LATEST_MULLVAD = $CURRENT_MULLVAD ]
	then
		date +%s > /var/log/mullvad-browser-installer-updater.lastexit.log
		echo $(date)" : Nothing to do :)"
		kill $xterm_pid
	else
		install_mullvad $IS_TEMPLATE
	fi
fi
